#include "header\GBA.h"
#include "header\BG.h"
#include "header\Timer.h"
#include "header\DMA.h"
#include "header\IRQ.h"
#include "header\sound.h"
#include "header\sprite.h"
#include "header\Blend.h"

#include "resource\BitMapFont.h"
#include "resource\data.h"

#include "lib.h"
#include "iwram.h"
#include "irq.h"
#include "syscall.h"

#include <stdlib.h>
#include <math.h>

//const int __gba_multiboot;  //GBANp

#define TRUE  (1)
#define FALSE (0)

#define HANABI_DOT_CNT 172			//ԉ΂̕\Ɏghbg̐
#define TAMA_CNT       10			//e̐
#define FLOWER_CNT     8			//ւ̐

//ȅԂ\܂
#define ATTRIBUTE_HANABI_WAITFLY 1	//
#define ATTRIBUTE_HANABI_FLY     2	//s
#define ATTRIBUTE_HANABI_BOMB    3	//J
#define ATTRIBUTE_HANABI_CANSEL  4	//

#define COLOR_WHITE RGB(31,31,31)
#define COLOR_BLOCK RGB( 0, 0, 0)

//---------------------------------------------------------------------------
typedef struct {
	double x;
	double y;
}ST_HANABI;			//JԂ̕\W

ST_HANABI HANABI[HANABI_DOT_CNT];

typedef struct {
	u8     status;		//݂̒ȅ
	double x;			//ˈʒu
	double y;			
	double v0x;			//̑x
	double v0y;			//̑x
	double time;		//oߎ
	double bomb;		//ʒu
	u8     angle;		//ˊpx
	u8     speed;		//Xs[h
	u8     ring;		//ւ̐
	u8     flower;		//\̗ւ̐
	u8     cnt;			//\̓_̐
}ST_TAMA;

ST_TAMA TAMA[TAMA_CNT];

double GlobalSpeed;
double Radian;

//ւɓ_\Ԋůpx  36360/3610\܂
u8 Angle [FLOWER_CNT]  = {36,20,15,15,15,15,15,15};
//ւ̔a
u8 Radius[FLOWER_CNT]  = {5,9,13,17,21,25,29,32};
//---------------------------------------------------------------------------
void Init();
void InitHanabi();
void InitTamaAll();
void InitTama(u8);

void TamaFly(u8);
void TamaBomb(u8);
void TamaCansel(u8);

inline double CalcTamaVectorX(u8);
inline double CalcTamaVectorY(u8);
//---------------------------------------------------------------------------
int main(void)
{
	Init();
	InitHanabi();
	InitTamaAll();

	REG_DISPCNT = MODE_3 | BG2_ENABLE;

	u8 i;
	for(;;)
	{
		//WaitForVsync();

		for(i=0; i<TAMA_CNT; i++)
		{
			switch(TAMA[i].status)
			{
			case ATTRIBUTE_HANABI_WAITFLY:  InitTama(i); break;
			case ATTRIBUTE_HANABI_FLY:       TamaFly(i); break;
			case ATTRIBUTE_HANABI_BOMB:     TamaBomb(i); break;
			case ATTRIBUTE_HANABI_CANSEL: TamaCansel(i); break;
			}
		}
	}

	return 0;
}
//---------------------------------------------------------------------------
void Init()
{
	GlobalSpeed = 0.001;
	Radian      = 3.14 / 180.0;
}
//---------------------------------------------------------------------------
void InitTamaAll()
{
	u8 i;
	for(i=0; i<TAMA_CNT; i++)
	{
		InitTama(i);
	}
}
//---------------------------------------------------------------------------
void InitTama(u8 num)
{
	TAMA[num].angle  = 55 + rand() % 70;
	TAMA[num].speed  = 30 + rand() % 10;
	TAMA[num].x      = 240 / 2;
	TAMA[num].y      = 159;
	TAMA[num].v0x    = TAMA[num].speed * cos(TAMA[num].angle * Radian);
	TAMA[num].v0y    = TAMA[num].speed * sin(TAMA[num].angle * Radian);

	TAMA[num].ring   = rand() % 6 + 2;
	TAMA[num].bomb   = 32 + rand() % 80;
	TAMA[num].time   = 0;
	TAMA[num].flower = 0;
	TAMA[num].cnt    = 0;

	TAMA[num].status = ATTRIBUTE_HANABI_FLY;
}
//---------------------------------------------------------------------------
//JԂ̓_̑Έʒu߂
void InitHanabi()
{
	u16 i,j,k=0;
	for(i=0; i<FLOWER_CNT; i++)
	{
		for(j=0; j<360; j+=Angle[i])
		{
			HANABI[k].x = Radius[i] * sin(j*Radian);
			HANABI[k].y = Radius[i] * cos(j*Radian);
			k++;
		}
	}
}
//---------------------------------------------------------------------------
void TamaFly(u8 num)
{
	//\
	Mode3DrawDot(TAMA[num].x, TAMA[num].y, COLOR_BLOCK);

	if(TAMA[num].y > TAMA[num].bomb)
	{
		TAMA[num].time += GlobalSpeed;
		TAMA[num].x    += CalcTamaVectorX(num);
		TAMA[num].y    -= CalcTamaVectorY(num);

		//\
		Mode3DrawDot(TAMA[num].x, TAMA[num].y, COLOR_WHITE);
	}
	else
	{
		TAMA[num].status = ATTRIBUTE_HANABI_BOMB;
	}
}
//---------------------------------------------------------------------------
void TamaBomb(u8 num)
{
	u8 cnt = 360 / Angle[ TAMA[num].flower++ ];
	u8 i;
	for(i=0; i<cnt; i++)
	{
		Mode3DrawDot(TAMA[num].x + HANABI[ TAMA[num].cnt ].x,
					 TAMA[num].y + HANABI[ TAMA[num].cnt ].y,
					 COLOR_WHITE);

		TAMA[num].cnt++;
	}

	if(TAMA[num].flower > TAMA[num].ring)
	{
		TAMA[num].status = ATTRIBUTE_HANABI_CANSEL;
		TAMA[num].flower = 0;
		TAMA[num].cnt    = 0;
	}
}
//---------------------------------------------------------------------------
void TamaCansel(u8 num)
{
	u8 cnt = 360 / Angle[ TAMA[num].flower++ ];
	u8 i;
	for(i=0; i<cnt; i++)
	{
		Mode3DrawDot(TAMA[num].x + HANABI[ TAMA[num].cnt ].x,
					 TAMA[num].y + HANABI[ TAMA[num].cnt ].y,
					 COLOR_BLOCK);

		TAMA[num].cnt++;
	}

	if(TAMA[num].flower > TAMA[num].ring)
	{
		TAMA[num].status = ATTRIBUTE_HANABI_WAITFLY;
	}
}
//---------------------------------------------------------------------------
//̍WvZ
inline double CalcTamaVectorX(u8 num)
{
	return TAMA[num].v0x * TAMA[num].time;
}
//---------------------------------------------------------------------------
//̍WvZ
inline double CalcTamaVectorY(u8 num)
{
	double v0y   = TAMA[num].v0y;
	double t     = TAMA[num].time;
	double g     = 9.8;
	double t2    = t * t;
	double omake = 20.0;		//oXiOOG

	return v0y * t - g/2 * t2 * omake;
}
